"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const path = __importStar(require("path"));
const yargs_1 = __importDefault(require("yargs"));
const core_1 = __importStar(require("@react-vector-graphics/core"));
const conf = __importStar(require("./config"));
const configResultHandler = (config, logger) => (result) => {
    if ((result === null || result === void 0 ? void 0 : result.filepath) && !result.isEmpty) {
        logger.info(`Loaded config from ${result.filepath}`);
        Object.assign(config, result.config);
        const configDir = path.dirname(result.filepath);
        if (configDir !== process.cwd()) {
            logger.info(`Changing current directory to ${configDir}`);
            process.chdir(configDir);
        }
    }
    else if (result === null || result === void 0 ? void 0 : result.isEmpty) {
        logger.info(`Skipping empty config at ${result.filepath}`);
    }
    else {
        logger.info('No config loaded');
    }
};
const getConfig = (config, logger) => __awaiter(void 0, void 0, void 0, function* () {
    const currentDir = process.cwd();
    const handleConfig = configResultHandler(config, logger);
    logger.info(`Searching for config in ${currentDir}`);
    const result = yield conf.find(currentDir);
    handleConfig(result);
    logger.info('Start getting cli options');
    const { argv } = yargs_1.default(process.argv)
        .usage('Usage: $0 --config [config]')
        .option('config', {
        default: result === null || result === void 0 ? void 0 : result.filepath,
        describe: 'Config file path',
        type: 'string',
    })
        .demandOption(['config']);
    if ((result === null || result === void 0 ? void 0 : result.filepath) !== argv.config) {
        yield conf.load(argv.config).then(handleConfig);
    }
    return config;
});
exports.run = () => __awaiter(void 0, void 0, void 0, function* () {
    const defaultConfig = conf.init();
    const logger = core_1.getLogger();
    const config = yield getConfig(defaultConfig, logger);
    if (!config.plugins.length) {
        logger.info('Setting the minimal plugin configuration');
        const assetPlugin = '@react-vector-graphics/plugin-assets';
        config.plugins = [assetPlugin, '@svgr/plugin-jsx', assetPlugin];
    }
    yield core_1.default({ config, logger });
});
